/*

   CREATE FUNCTION spin_wait_delay RETURNS INTEGER SONAME "udf_spin_wait_delay.so";
	 select spin_wait_delay();
   DROP FUNCTION spin_wait_delay;

*/

#ifdef STANDARD
/* STANDARD is defined, don't use any mysql functions */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#ifdef __WIN__
typedef unsigned __int64 ulonglong;   /* Microsofts 64 bit types */
typedef __int64 longlong;
#else
typedef unsigned long long ulonglong;
typedef long long longlong;
#endif /*__WIN__*/
#else
#include <my_global.h>
#include <my_sys.h>
#if defined(MYSQL_SERVER)
#include <m_string.h>   /* To get strmov() */
#else
/* when compiled as standalone */
#include <string.h>
#define strmov(a,b) stpcpy(a,b)
#define bzero(a,b) memset(a,0,b)
#define memcpy_fixed(a,b,c) memcpy(a,b,c)
#endif
#endif
#include <mysql.h>
#include <ctype.h>

// This is for our spin_wait_delay
#include "srv0srv.h"

static pthread_mutex_t LOCK_hostname;

#ifdef HAVE_DLOPEN

/* These must be right or mysqld will not find the symbol! */

my_bool spin_wait_delay_init(UDF_INIT *initid, UDF_ARGS *args, char *message);
        
longlong spin_wait_delay(UDF_INIT *initid, UDF_ARGS *args, char *is_null, char *error);

longlong spin_wait_delay(UDF_INIT *initid __attribute__((unused)), UDF_ARGS *args,
                    char *is_null __attribute__((unused)), char *error __attribute__((unused)))
{
  longlong val = 0;

  // We set it the value
  if ( args->arg_count == 1 ) {
    val = *((longlong*) args->args[0]);
	  srv_spin_wait_delay = val;
	}

  // We get the value
  val = (ulint)srv_spin_wait_delay;

	return val;
}

my_bool spin_wait_delay_init(UDF_INIT *initid __attribute__((unused)),
                        UDF_ARGS *args __attribute__((unused)),
                        char *message __attribute__((unused)))
{
  return 0;
}

#endif /* HAVE_DLOPEN */
